import java.io.*;
import java.net.*;

public class ServidorMultihilo{

	private static int NUM_ESCLAVOS=1000;
	
	public static void main(String []args){
		try{
			int port;
			File fich;
			if(args.length==2){
				port=Integer.parseInt(args[0]);
				fich=new File(args[1]);
				
			}else{
				System.out.println("Usage: java ServidorMultihilo <port> <file>");
				port=1025;
				fich=File.createTempFile("pizarra",".pz",new File("."));
			}
			if(!fich.exists()){
				fich.createNewFile();
			}
			System.out.println("Puerto: "+port);
			System.out.println("Pizarra: "+fich.getAbsolutePath());
			//Creamos un array de NUM_ESCLAVOS
			Monohilo []hilos=new Monohilo[NUM_ESCLAVOS];
			//Iniciamos los esclavos...
			for(int i=0;i<NUM_ESCLAVOS;i++){
				hilos[i]=new Monohilo(fich);
				hilos[i].start();
			}
			System.out.println("Los "+NUM_ESCLAVOS+" hilos estan preparados");
			//Iniciamos el controlador...
			Controlador control=new Controlador(hilos);
			control.start();
			//Iniciamos el Socket y esperamos a que haya peticiones...
			ServerSocket sSocket=new ServerSocket(port);
			Socket sock;
			while(true){
				System.out.println("Esperando peticion...");
				try{
					sock=sSocket.accept();
				}catch(IOException exc){
					System.out.println("Error con la peticion.\r\n"+exc);
					continue;
				}
				System.out.println("Peticion aceptada");
				//Buscamos cual es el primer esclavo libre
				for(int i=0;i<NUM_ESCLAVOS;i++){
					if(!hilos[i].stillAlive()){
						//Hilo esta libre. Definimos el Socket
						hilos[i].setSocket(sock);
						//Iniciamos el hilo
						hilos[i].go();
						break;
					}
					//Si estan todos los hilos ocupados
					if(i==NUM_ESCLAVOS-1){
						//Denegamos la conexion
						sock.close();
					}
				}
			}
		}catch(IOException ioe){
			System.out.println("Error en la ejecucion.\r\n"+ioe);
		}
	}
}
